#define INCLUDE_THREADS
#include "../../config.h"

#ifdef MBTK_HAVE_THREAD_PTHREAD

typedef struct mbtk_be_thread_s {
	pthread_t thread;
} mbtk_be_thread_t;

typedef int mbtk_be_sem_t;
#define MBTK_BE_INVALID_SEM -1

#endif

#ifdef MBTK_HAVE_THREAD_WIN32

typedef struct mbtk_be_thread_s {
	HANDLE thread;
	void *(*func)(void *);
	void *udata;
} mbtk_be_thread_t;

typedef HANDLE mbtk_be_sem_t;
#define MBTK_BE_INVALID_SEM 0

#endif



#ifdef MBTK_BE_INVALID_SEM
/* Create and run new thread. Return 0 on success. */
int mbtk_be_thread_create(mbtk_be_thread_t *thr, void *(*func)(void *), void *udata);

/* Create a semaphore with an initial counter value. Returns
   MBTK_BE_INVALID_SEM on error */
mbtk_be_sem_t mbtk_be_semget(int init_cnt);

/* Remove a semaphore - can't fail */
void mbtk_be_semdel(mbtk_be_sem_t sem);

/* Decrease semaphore value. If block is true, wait until decreasing is
   possible. If block is false and decreasing is not possible, fail.
   Returns 0 on success. */
int mbtk_be_semwait(mbtk_be_sem_t sem, int block);

/* Increase semaphore value. Returns 0 on success. */
int mbtk_be_sempost(mbtk_be_sem_t sem);
#endif
