static mbtk_mocu_t *mbtk_sdl2_mocu_create_named(mbtk_display_t *disp, mbtk_mocu_named_t name)
{
	int shape;

	switch(name) {
		case MBTK_MOCU_ARROW:     shape = SDL_SYSTEM_CURSOR_ARROW; break;
		case MBTK_MOCU_IBEAM:     shape = SDL_SYSTEM_CURSOR_IBEAM; break;
		case MBTK_MOCU_CROSSHAIR: shape = SDL_SYSTEM_CURSOR_CROSSHAIR; break;
		case MBTK_MOCU_HAND:      shape = SDL_SYSTEM_CURSOR_HAND; break;
		case MBTK_MOCU_HARROW:    shape = SDL_SYSTEM_CURSOR_SIZEWE; break;
		case MBTK_MOCU_VARROW:    shape = SDL_SYSTEM_CURSOR_SIZENS; break;
		default: return NULL;
	}

	return (mbtk_mocu_t *)SDL_CreateSystemCursor(shape);
}

static mbtk_mocu_t *mbtk_sdl2_mocu_create_pixmap(mbtk_display_t *disp, int width, int height, unsigned const char *px, unsigned const char *mask, int hot_x, int hot_y)
{
	SDL_Cursor *c;
	int n, size = width * height / 8;
	unsigned char *o, *px2 = malloc(size);
	const unsigned char *i;

	/* invert every pixel value */
	for(n = 0, i = px, o = px2; n < size; n++, i++, o++)
		*o = ~*i;

	c = SDL_CreateCursor(px2, mask, width, height, hot_x, hot_y);
	free(px2);
	return (mbtk_mocu_t *)c;
}

static void mbtk_sdl2_mocu_free_cursor(mbtk_display_t *disp, mbtk_mocu_t *curs)
{
	SDL_FreeCursor((SDL_Cursor *)curs);
}

static void mbtk_sdl2_mocu_set_cursor(mbtk_display_t *disp, mbtk_mocu_t *curs)
{
	SDL_SetCursor((SDL_Cursor *)curs);
}


