#include <libmbtk/config.h>
#include <stdlib.h>
#include <genht/hash.h>
#include <libmbtk/widget.h>
#include "callback.h"

mbtk_callback_t mbtk_htcb_invalid = {0};

#define HT_INVALID_VALUE mbtk_htcb_invalid
#define HT(x) mbtk_htcb_ ## x
#include <genht/ht.c>

int mbtk_htcb_keyeq(mbtk_htcb_key_t a, mbtk_htcb_key_t b)
{
	return a == b;
}

unsigned mbtk_htcb_keyhash(mbtk_htcb_key_t k)
{
	return longhash(k);
}

#undef HT

void mbtk_callback_set_noarg(mbtk_widget_t *w, mbtk_kw_t id, int (*cb)(mbtk_widget_t *w, mbtk_kw_t id, void *user_data), void *user_data)
{
	mbtk_callback_t tmp;

	if (w->callbacks == NULL)
		w->callbacks = mbtk_htcb_alloc(mbtk_htcb_keyhash, mbtk_htcb_keyeq);

	tmp.func.noarg = cb;
	tmp.user_data = user_data;
	tmp.inhibit = 0;
	mbtk_htcb_set(w->callbacks, id, tmp);
}

void mbtk_callback_uninit(mbtk_widget_t *w)
{
	if (w->callbacks == NULL)
		return;
	mbtk_htcb_free(w->callbacks);
	w->callbacks = NULL;
}

