#ifndef MBTK_CALLBACK_H
#define MBTK_CALLBACK_H

#include <libmbtk/config.h>
#include <libmbtk/global_typedefs.h>


typedef struct mbtk_callback_s {
	union {
		int (*noarg)(mbtk_widget_t *w, mbtk_kw_t id, void *user_data);
	} func;
	void *user_data;
	unsigned inhibit:1;
} mbtk_callback_t;


typedef mbtk_kw_t mbtk_htcb_key_t;
typedef mbtk_callback_t mbtk_htcb_value_t;
#define HT(x) mbtk_htcb_ ## x
#include <genht/ht.h>
#undef HT

int mbtk_htcb_keyeq(mbtk_htcb_key_t a, mbtk_htcb_key_t b);
unsigned mbtk_htcb_keyhash(mbtk_htcb_key_t k);

/* Removes all callbacks from a widget */
void mbtk_callback_uninit(mbtk_widget_t *w);

#endif
