#ifndef LIBMBTK_WIDGET_CHECKBOX_H
#define LIBMBTK_WIDGET_CHECKBOX_H

#include <libmbtk/config.h>
#include <libmbtk/widget.h>
#include <libmbtk/widget_inlines.h>

/* Checkbox: has two states, in activated state includes a mark;
   can be clicked a mouse click release or enter release */
typedef struct mbtk_checkbox_s {
	mbtk_widget_t w;
} mbtk_checkbox_t;

/* Create a new checkbox. Handler is set to hand_toggle. */
mbtk_checkbox_t *mbtk_checkbox_new(mbtk_checkbox_t *caller_alloced);

/* Called after the release on a click on the checkbox */
void mbtk_checkbox_callback_toggle(mbtk_checkbox_t *b, int (*cb)(mbtk_widget_t *w, mbtk_kw_t id, void *user_data), void *user_data);


MBTK_WIDGET_INLINES(checkbox)

#endif
