#include <assert.h>
#include <libmbtk/widget.h>
#include <libmbtk/widget_imp.h>
#include <libmbtk/widget/button.h>
#include <libmbtk/widget/hand_toggle.h>

#include <libmbtk/widget/tbutton.h>

mbtk_tbutton_t *mbtk_tbutton_new(mbtk_tbutton_t *caller_alloced)
{
	mbtk_tbutton_t *res = (mbtk_tbutton_t *)mbtk_button_new((mbtk_button_t *)caller_alloced);
	assert(sizeof(mbtk_button_t) == sizeof(mbtk_tbutton_t));
	mbtk_handler_toggle_install(&res->w);
	return res;
}

mbtk_tbutton_t *mbtk_tbutton_new_with_label(const char *str)
{
	mbtk_tbutton_t *res = (mbtk_tbutton_t *)mbtk_button_new_with_label(str);
	assert(sizeof(mbtk_button_t) == sizeof(mbtk_tbutton_t));
	mbtk_handler_toggle_install(&res->w);
	return res;
}

mbtk_tbutton_t *mbtk_tbutton_new_with_widget(mbtk_tbutton_t *caller_alloced, mbtk_widget_t *child)
{
	mbtk_tbutton_t *res = (mbtk_tbutton_t *)mbtk_button_new_with_widget((mbtk_button_t *)caller_alloced, child);
	assert(sizeof(mbtk_button_t) == sizeof(mbtk_tbutton_t));
	mbtk_handler_toggle_install(&res->w);
	return res;
}

mbtk_widget_t *mbtk_tbutton_set_child(mbtk_tbutton_t *parent, mbtk_widget_t *w)
{
	return mbtk_button_set_child((mbtk_button_t *)parent, w);
}

void mbtk_tbutton_callback_toggle(mbtk_tbutton_t *b, int (*cb)(mbtk_widget_t *w, mbtk_kw_t id, void *user_data), void *user_data)
{
	mbtk_kw_t kw_toggled;
	mbtk_kw_cache(kw_toggled, "toggled");
	mbtk_callback_set_noarg(&b->w, kw_toggled, cb, user_data);
}
